package ca.uwaterloo.cs.gmysql;

public class Version {
	public final static int MAJOR = 1;
	public final static int MINOR = 0;
	public final static int BUILD = 2;
	public final static String COMPILED = "29th January, 2016";

	public static String Number()
	{
		return(MAJOR + "." + MINOR + "." + BUILD);
	}

	public static String formatNumber(long l)
	{
		String	val  = Long.toString(l);
		String  ret  = "";
		int		lth  = val.length();

		for (int i = 0;; ) {
			ret += val.charAt(i);
			if (++i >= lth) {
				break;
			}
			if (((lth - i) % 3) == 0) {
				ret += ',';
		}	}
		return ret;
	}

	public static int	InternalNumber()
	{
		return (((MAJOR * 1000) + MINOR) * 1000) + BUILD;
	}

	public static String CompileDate()
	{
		return("Compiled: " + COMPILED);
	}

	public static String Detail(String property)
	{
		String result;

		try {
			// This will fail if an applet
			result = System.getProperty(property);
		} catch (Exception e) {
			result = "**Denied**";
			System.out.println("System.getProperty(\"" + property + "\"): " + e.getMessage());
		};
		return(result);
	}

	public static String authorsAndCopyright()
	{
		String  result;

		result	= "Gsql " + Version.Number() + " " + Version.CompileDate() + "\n"
		        + "Developed at the University of Waterloo under the supervision of Prof. Joanne Atlee\n"
		        + "Original Author: Ian Davis\n";

		return result;
	}

	public static String Details()
	{
		String  result;
		Runtime	r;

		// System.getProperties().list(System.out);

		result  = authorsAndCopyright()
				+ "\n\n";

		try		{ //set if possible
				result += "Run Time Engine: " + Detail("java.vendor") + " " + Detail("java.version") + "\n"
				        + "Virtual Machine: " + Detail("java.vm.name") + " " + Detail("java.vm.version") + "\n"
				        + "V/M Vendor: " + Detail("java.vm.vendor") + "\n" 
				        + "Operating System: '" + Detail("os.name") + "' " + Detail("os.arch") + " " + Detail("os.version") + "\n"
				        + "Patch level: " + Detail("sun.os.patch.level") + "\n"
				        + "User id: " + Detail("user.name") + "\n"
				        + "Directory: " + Detail("user.dir") + "\n";

				r       = Runtime.getRuntime();
				result += "Memory: " + formatNumber(r.totalMemory()) + " - Free: " + formatNumber(r.freeMemory()) + " = " + formatNumber(r.totalMemory() - r.freeMemory()) + " Max: " + formatNumber(r.maxMemory()) + "\n";
				r.gc();
				result += "Memory: " + formatNumber(r.totalMemory()) + " - Free: " + formatNumber(r.freeMemory()) + " = " + formatNumber(r.totalMemory() - r.freeMemory()) + " Max: " + formatNumber(r.maxMemory()) + "\n";
				

		} catch (Exception e) {}

		return(result);
	}
}
