package ca.uwaterloo.cs.gmysql.data;

public class Edge_list_attributes extends Row {

	private static Edge_list_attributes g_head = null;
	private static Edge_list_attributes g_tail = null;

	public Edge_list_attributes	m_next;
	public String				m_class;
	public String				m_start;
	public String				m_end;
	public String				m_attribute;
	public int					m_pos;
	public String				m_value;

	public Edge_list_attributes(String class1, String start1, String end1, String attribute, int pos, String value)
	{
		m_next      = null;
		m_class     = class1;
		m_start     = id(start1);
		m_end       = id(end1);
		m_attribute = attribute;
		m_pos       = pos;
		m_value     = value;

		if (g_head == null) {
			g_head = g_tail = this;
		} else {
			g_tail.m_next = this;
			g_tail        = this;
		}
	}

	public static void create(String schema, String version)
	{
		System.out.print("create table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("edge_list_attributes (");
		if (version != null) {
			System.out.println("    version   varchar(255),");
		}
		System.out.println("    class     varchar(255) not null,");
		System.out.println("    start     " + idtype() + ",");
		System.out.println("    end       " + idtype() + ",");
		System.out.println("    attribute varchar(255) not null,");
		System.out.println("    pos       int unsigned not null,");
		System.out.println("    value     varchar(10000)");
		System.out.println(")");
		System.out.println("default character set utf8");
		System.out.println("ENGINE=Innodb;");
		System.out.println("");
	}

	public static void dump(String schema, String version)
	{
		Edge_list_attributes at;
		char		   c;

		if (g_head == null) {
			return;
		}
		System.out.print("insert into ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("edge_list_attributes values");
		c = ' ';
		for (at = g_head; at != null; at = at.m_next) {
			System.out.print(c);
			System.out.print('(');
			if (version != null) {
				sqlstring(version);
				System.out.print(',');
			}
			sqlstring(at.m_class);
			System.out.print(',');
			idstring(at.m_start);
			System.out.print(',');
			idstring(at.m_end);
			System.out.print(',');
			sqlstring(at.m_attribute);
			System.out.print(',');
			System.out.print(at.m_pos);
			System.out.print(',');
			sqlstring(at.m_value);
			System.out.println(')');
			c = ',';
		}
		System.out.println(';');
		System.out.println("");
	}

	public static void augment(String schema, String version)
	{
	}

	public static void index(String schema, String version)
	{
		System.out.print("alter table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("edge_list_attributes");
		System.out.println("    add index index_edge_list_attributes_start_end_class using btree (start, end, class),");
		System.out.println("    add index index_edge_list_attributes_end_class       using btree (end, class);");
		System.out.println("");
	}
}

