package ca.uwaterloo.cs.gmysql.data;

import java.util.Set;
import java.util.Iterator;
import java.util.Map.Entry;

public class Ids extends Row {

	public Ids()
	{
	}

	public static void create(String schema, String version)
	{
		System.out.print("create table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("ids (");
		if (version != null) {
			System.out.println("    version   varchar(255),");
		}
		System.out.println("    id        " + idtype() + ",");
		System.out.println("    old       varchar(255) not null");
		System.out.println(")");
		System.out.println("default character set utf8");
		System.out.println("ENGINE=Innodb;");
		System.out.println("");
	}

	public static void dump(String schema, String version)
	{
		Set<Entry<String,Integer>>		set = g_ids.entrySet();
		Iterator<Entry<String,Integer>>	i = set.iterator();
		Entry<String,Integer>           entry;
		char		   						c;

		if (!i.hasNext()) {
			return;
		}

		System.out.print("insert into ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("ids values");
		c = ' ';
		while (i.hasNext()) {
			entry = i.next();
			System.out.print(c);
			System.out.print('(');
			if (version != null) {
				sqlstring(version);
				System.out.print(',');
			}
			System.out.print(entry.getValue().intValue());
			System.out.print(',');
			sqlstring(entry.getKey());
			System.out.println(')');
			c = ',';
		}
		System.out.println(';');
		System.out.println("");
	}

	public static void augment(String schema, String version)
	{
	}

	public static void index(String schema, String version)
	{
		System.out.print("alter table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("ids");
		System.out.println("    add index index_ids_id  using btree (id),");
		System.out.println("    add index index_ids_old using btree (old);");
		System.out.println("");
	}
}

