package ca.uwaterloo.cs.gmysql.data;

public class Node_attributes extends Row {

	private static Node_attributes g_head = null;
	private static Node_attributes g_tail = null;

	public Node_attributes	m_next;
	public String			m_id;
	public String			m_attribute;
	public String			m_value;

	public Node_attributes(String id1, String attribute, String value)
	{
		m_next      = null;
		m_id        = id(id1);
		m_attribute = attribute;
		m_value     = value;

		if (g_head == null) {
			g_head = g_tail = this;
		} else {
			g_tail.m_next = this;
			g_tail        = this;
		}
	}

	public static void create(String schema, String version)
	{
		System.out.print("create table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("node_attributes (");
		if (version != null) {
			System.out.println("    version   varchar(255),");
		}
		System.out.println("    id        " + idtype() + ",");
		System.out.println("    attribute varchar(255) not null,");
		System.out.println("    value     varchar(10000)");
		System.out.println(")");
		System.out.println("default character set utf8");
		System.out.println("ENGINE=Innodb;");
		System.out.println("");
	}

	public static void dump(String schema, String version)
	{
		Node_attributes at;
		char		   c;

		if (g_head == null) {
			return;
		}
		System.out.print("insert into ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("node_attributes values");
		c = ' ';
		for (at = g_head; at != null; at = at.m_next) {
			System.out.print(c);
			System.out.print('(');
			if (version != null) {
				sqlstring(version);
				System.out.print(',');
			}
			idstring(at.m_id);
			System.out.print(',');
			sqlstring(at.m_attribute);
			System.out.print(',');
			sqlstring(at.m_value);
			System.out.println(')');
			c = ',';
		}
		System.out.println(';');
		System.out.println("");
	}

/*
	public static void dump(String schema, String version)
	{
		Node_attributes at;
		char		   c;

		c = ' ';
		for (at = g_head; at != null; at = at.m_next) {
			System.out.print("insert into ");
			if (schema != null) {
				System.out.print(schema);
			}
			System.out.print("node_attributes values (");
			if (version != null) {
				sqlstring(version);
				System.out.print(',');
			}
			idstring(at.m_id);
			System.out.print(',');
			sqlstring(at.m_attribute);
			System.out.print(',');
			sqlstring(at.m_value);
			System.out.println(");");
		}
	}
*/
	public static void augment(String schema, String version)
	{
	}


	public static void index(String schema, String version)
	{
		System.out.print("alter table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("node_attributes");
		System.out.println("    add index index_node_attributes_id_attribute using btree (id, attribute);");
		System.out.println("");
	}
}

