package ca.uwaterloo.cs.gmysql.data;

public class Nodes extends Row {

	private static Nodes g_head = null;
	private static Nodes g_tail = null;

	public Nodes	m_next;
	public String	m_id;
	public String	m_class;

	public Nodes(String id1, String class1)
	{
		m_next  = null;
		m_id    = id(id1);
		m_class = class1;

		if (g_head == null) {
			g_head = g_tail = this;
		} else {
			g_tail.m_next = this;
			g_tail        = this;
		}
	}

	public static void create(String schema, String version)
	{
		System.out.print("create table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("nodes (");
		if (version != null) {
			System.out.println("    version   varchar(255),");
		}
		System.out.println("    id        " + idtype() + ",");
		System.out.println("    class     varchar(255) not null");
		System.out.println(")");
		System.out.println("default character set utf8");
		System.out.println("ENGINE=Innodb;");
		System.out.println("");
	}

	public static void dump(String schema, String version)
	{
		Nodes	at;
		char	c;

		if (g_head == null) {
			return;
		}
		System.out.print("insert into ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("nodes values");
		c = ' ';
		for (at = g_head; at != null; at = at.m_next) {
			System.out.print(c);
			System.out.print('(');
			if (version != null) {
				sqlstring(version);
				System.out.print(',');
			}
			idstring(at.m_id);
			System.out.print(',');
			sqlstring(at.m_class);
			System.out.println(')');
			c = ',';
		}
		System.out.println(';');
		System.out.println("");
	}

	public static void augment(String schema, String version)
	{
		System.out.print("insert into ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("nodes");
		System.out.print("select ");
		if (version != null) {
			sqlstring(version);
			System.out.print(',');
		}
		System.out.println("id,'$ENTITY'");
		System.out.println(" from (select distinct id");
		System.out.print  ("         from ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("node_attributes t1");
		System.out.println("where id not in");
		System.out.println("        (select id");
		System.out.print  ("           from ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("nodes");
		System.out.println("        )");
		System.out.println("      ) t3;");
		System.out.println("");
	}

	public static void index(String schema, String version)
	{
		System.out.print("alter table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("nodes");
		System.out.println("    add index index_nodes_id    using btree (id),");
		System.out.println("    add index index_nodes_class using btree (class);");
		System.out.println("");
	}
}

