package ca.uwaterloo.cs.gmysql.data;

public class Schema_edge_connects extends Row {

	private static Schema_edge_connects	g_head = null;
	private static Schema_edge_connects g_tail = null;

	public Schema_edge_connects	m_next;
	public String				m_class;
	public String				m_start_class;
	public String				m_end_class;

	public Schema_edge_connects(String class1, String start_class, String end_class)
	{
		m_next        = null;
		m_class       = class1;
		m_start_class = start_class;
		m_end_class   = end_class;

		if (g_head == null) {
			g_head = g_tail = this;
		} else {
			g_tail.m_next = this;
			g_tail        = this;
		}
	}

	public static void create(String schema, String version)
	{
		System.out.print("create table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_edge_connects (");
		if (version != null) {
			System.out.println("    version     varchar(255),");
		}
		System.out.println("    class       varchar(255) not null,");
		System.out.println("    start_class varchar(255) not null,");
		System.out.println("    end_class   varchar(255) not null");
		System.out.println(")");
		System.out.println("default character set utf8");
		System.out.println("ENGINE=Innodb;");
		System.out.println("");
	}

	public static void dump(String schema, String version)
	{
		Schema_edge_connects at;
		char				 c;

		if (g_head == null) {
			return;
		}

		System.out.print("insert into ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_edge_connects values");
		c = ' ';
		for (at = g_head; at != null; at = at.m_next) {
			System.out.print(c);
			System.out.print('(');
			if (version != null) {
				sqlstring(version);
				System.out.print(',');
			}
			sqlstring(at.m_class);
			System.out.print(',');
			sqlstring(at.m_start_class);
			System.out.print(',');
			sqlstring(at.m_end_class);
			System.out.println(')');
			c = ',';
		}
		System.out.println(';');
		System.out.println("");
	}

	public static void augment(String schema, String version)
	{
	}

	public static void index(String schema, String version)
	{
		System.out.print("alter table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_edge_connects");
		System.out.println("    add index index_schema_edge_connects_class_start_end using btree (class, start_class, end_class),");
		System.out.println("    add index index_schema_edge_connects_start_end       using btree (start_class, end_class),");
		System.out.println("    add index index_schema_edge_connects_end             using btree (end_class);");
		System.out.println("");
	}
}
