package ca.uwaterloo.cs.gmysql.data;

public class Schema_node_inherits extends Row {

	private static Schema_node_inherits	g_head = null;
	private static Schema_node_inherits g_tail = null;

	public Schema_node_inherits	m_next;
	public String				m_class;
	public String				m_subclass;

	public Schema_node_inherits(String class1, String subclass1)
	{
		m_next     = null;
		m_class    = class1;
		m_subclass = subclass1;

		if (g_head == null) {
			g_head = g_tail = this;
		} else {
			g_tail.m_next = this;
			g_tail        = this;
		}
	}

	public static void create(String schema, String version)
	{
		System.out.print("create table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_node_inherits (");
		if (version != null) {
			System.out.println("    version    varchar(255),");
		}
		System.out.println("    class      varchar(255) not null,");
		System.out.println("    superclass varchar(255) not null");
		System.out.println(")");
		System.out.println("default character set utf8");
		System.out.println("ENGINE=Innodb;");
		System.out.println("");
	}

	public static void dump(String schema, String version)
	{
		Schema_node_inherits at;
		char				 c;

		if (g_head == null) {
			return;
		}
		System.out.print("insert into ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_node_inherits values");
		c = ' ';
		for (at = g_head; at != null; at = at.m_next) {
			System.out.print(c);
			System.out.print('(');
			if (version != null) {
				sqlstring(version);
				System.out.print(',');
			}
			sqlstring(at.m_class);
			System.out.print(',');
			sqlstring(at.m_subclass);
			System.out.println(')');
			c = ',';
		}
		System.out.println(';');
		System.out.println("");
	}

	public static void augment(String schema, String version)
	{
		System.out.print("insert into ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_node_inherits");
		System.out.print("select ");
		if (version != null) {
			sqlstring(version);
			System.out.print(',');
		}
		System.out.println("class, '$ENTITY'");
		System.out.println(" from (select distinct class");
		System.out.print  ("         from ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_node_attributes t1");
		System.out.println("        where class != '$ENTITY'");
		System.out.println("          and class not in");
		System.out.println("             (select class");
		System.out.print  ("                from ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_node_inherits t2");
		System.out.println("             )");
		System.out.println("      ) t3;");
		System.out.println("");
	}

	public static void index(String schema, String version)
	{
		System.out.print("alter table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_node_inherits");
		System.out.println("    add index index_schema_node_inherits_class_superclass using btree (class,superclass),");
		System.out.println("    add index index_schema_node_inherits_superclass       using btree (superclass);");
		System.out.println("");
	}
}


