package ca.uwaterloo.cs.gmysql.data;

public class Schema_node_list_attributes extends Row {

	private static Schema_node_list_attributes g_head = null;
	private static Schema_node_list_attributes g_tail = null;

	public Schema_node_list_attributes	m_next;
	public String						m_class;
	public String						m_attribute;
	public int							m_pos;
	public String						m_value;

	public Schema_node_list_attributes(String class1, String attribute, int pos, String value)
	{
		m_next      = null;
		m_class     = class1;
		m_attribute = attribute;
		m_pos       = pos;
		m_value     = value;

		if (g_head == null) {
			g_head = g_tail = this;
		} else {
			g_tail.m_next = this;
			g_tail        = this;
		}
	}

	public static void create(String schema, String version)
	{
		System.out.print("create table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_node_list_attributes (");
		if (version != null) {
			System.out.println("    version   varchar(255),");
		}
		System.out.println("    class     varchar(255) not null,");
		System.out.println("    attribute varchar(255) not null,");
		System.out.println("    pos       int unsigned not null,");
		System.out.println("    value     varchar(10000)");
		System.out.println(")");
		System.out.println("default character set utf8");
		System.out.println("ENGINE=Innodb;");
		System.out.println("");
	}

	public static void dump(String schema, String version)
	{
		Schema_node_list_attributes at;
		char				   c;

		if (g_head == null) {
			return;
		}

		System.out.print("insert into ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_node_list_attributes values");
		c = ' ';
		for (at = g_head; at != null; at = at.m_next) {
			System.out.print(c);
			System.out.print('(');
			if (version != null) {
				sqlstring(version);
				System.out.print(',');
			}
			sqlstring(at.m_class);
			System.out.print(',');
			sqlstring(at.m_attribute);
			System.out.print(',');
			System.out.print(at.m_pos);
			System.out.print(',');
			sqlstring(at.m_value);
			System.out.println(')');
			c = ',';
		}
		System.out.println(';');
		System.out.println("");
	}

	public static void augment(String schema, String version)
	{
	}

	public static void index(String schema, String version)
	{
		System.out.print("alter table ");
		if (schema != null) {
			System.out.print(schema);
		}
		System.out.println("schema_node_list_attributes");
		System.out.println("    add index index_schema_node_list_attributes_class_attribute using btree (class, attribute);");
		System.out.println("");
	}
}


